{% extends "base.html" %}
{% block content %}

<script src="/static/dataTables/jquery.dataTables.min.js"></script>
<script src="/static/dataTables/dataTables.bootstrap.min.js"></script>
{% if tallyColumns %}
<script src="/static/dataTables/plugins/sum().js"></script>
{% endif %}
<link rel="stylesheet" type="text/css" href="/static/dataTables/dataTables.bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="/static/css/font-awesome.min.css">

<style>
.table td:first-child {
    text-align: center;
}​
</style>

<div class="container">
    <div class="row col-md-8" style="font-size:1.5em">
    <input class="btn-primary btn btn-sm" type="button" value="{%trans%}Form details{%endtrans%}" onClick="location.href='/forms/view/{{ form._id }}'">
    {{ form.slug }}
    </div>
    
    <div class="row col-md-4" style="text-align:right">
    <input id="editModeButton" class="btn-primary btn btn-sm" type="button" value="{%trans%}Enable edition{%endtrans%}" onClick="js:setEditMode();">
    <input class="btn-primary btn btn-sm" type="button" value="{%trans%}Download CSV{%endtrans%}" onClick="location.href='/forms/csv/{{ form._id }}'">
    <input class="btn-danger btn btn-sm" type="button" value="{%trans%}Delete all{%endtrans%}" onClick="location.href='/forms/delete-entries/{{ form._id }}'" {% if not form.totalEntries %}disabled{%endif%} >
    </div>
</div>

<div class="container">
    <hr style="margin-bottom:5px" />
    
    {% if form.editors[g.current_user._id|string] is defined %}
        <div id="toggle_notification" class="btn-group btn-toggle">
            <button id="notification_true" class="btn btn-xs btn-default {% if form.data.editors[g.current_user._id|string]['notification']['newEntry'] %}btn-success{% endif %}">{%trans%}True{%endtrans%}</button>
            <button id="notification_false" class="btn btn-xs btn-default {% if not form.data.editors[g.current_user._id|string]['notification']['newEntry'] %}btn-primary{% endif %}">{%trans%}False{%endtrans%}</button>
        </div>
        {%trans%}Notify me on each new entry{%endtrans%}
    {% endif %}
    
    <p>&nbsp;</p>

    <table id="entriesTable" style="display:none" class="table table-striped table-condensed">
    <thead>
        <tr>
        <th></th>
        {% for field in fieldIndex %}
            <th>{{ field['label'] }}</th>
        {% endfor %}
        </tr>
    </thead>

    <!-- Keep the data TD on one line! -->
    {% for entry in form.entries %}
    <tr>
        <td style="border-right: 1px solid #ccc; border-left: 1px solid #ccc;">
            <i class="fa fa-minus-circle delete-row-icon" aria-hidden="true"></i>
        </td>
        {% for field in fieldIndex %}
            <td style="border-right: 1px solid #ccc;">{{ entry[field['name']] }}</td>
        {% endfor %}
    </tr>
    {% endfor %}
    </table>
</div>

{% if form.editors[g.current_user._id|string] is defined %}
<script>
var csrftoken = "{{ csrf_token() }}";
var fieldIndex={{fieldIndex|tojson}};
var editMode = false;
var tallyColumns = {{tallyColumns|tojson}};

function setEditMode(){
    editMode = true;
    $('#editModeButton').removeClass('btn-primary');
    $('#editModeButton').addClass('btn-success');
    $('#editModeButton').val('{%trans%}Edition enabled{%endtrans%}');
    $('.delete-row-icon').addClass('enabled');
    $('#entriesTable tbody').addClass('entryCellHighlighter');
}
function getFieldValueInRow(fieldName, $row){
    var arrayLength = fieldIndex.length;
    for (var loop = 0; loop < arrayLength; loop++) {
        if (fieldIndex[loop]["name"] == fieldName) {
            return $row.children('td').eq(loop+1).html()
        }   
    }
    return null;
}
function getRowData($row) {
    var rowData = new Array();
    var arrayLength = fieldIndex.length;
    for (var loop = 0; loop < arrayLength; loop++) {      
        rowData.push({"name": fieldIndex[loop]["name"], "value": $row.children('td').eq(loop+1).html()})
    }
    return rowData;
}
$(document).ready(function() {
    var table = $('#entriesTable').DataTable({
        "language": {
            "url": "/static/dataTables-languages/{{g.current_user.language}}.js"
        },
        "initComplete": function(settings, json) {
            tallyColumns.forEach(function(column) {
                col=column+1;
                sum=table.column( col ).data().sum();
                $("#entriesTable th:nth-child("+ (col+1) +")" ).append( " <span class='col_sum'>("+sum+")</span>" );
            });
            $("#entriesTable").show();
        },
        "order": [[1, 'desc']],
        "columnDefs": [
            { "orderable": false, "targets": 0 }
        ]
    });
    $('.delete-row-icon').attr('title', "{%trans%}Delete entry{%endtrans%}");
});
// Edit cell
$('#entriesTable tbody').on('click', "td:not(.deleted-row):not(:nth-child(-n+2)):not(.cellEditionMode)", function () {
    if(editMode == false){
        return;
    }
    $(this).addClass('cellEditionMode');
    var cellValue = $(this).html();
    var $editor = $("<div style='white-space:nowrap;' initial_value=\""+ cellValue +"\"></div>");
    $editor.append("<input style='width:70%' type='text' value=\""+ cellValue +"\" />");
    $editor.append('<i class="fa fa-check-circle saveCellEdition" aria-hidden="true" title="{%trans%}Save{%endtrans%}"></i>');
    $editor.append('<i class="fa fa-times-circle cancelCellEdition" aria-hidden="true" title="{%trans%}Cancel{%endtrans%}"></i>');
    $(this).html($editor);
});
// Cancel edition
$('#entriesTable tbody').on('click', '.cancelCellEdition', function () {
    $(this).parents("td").removeClass('cellEditionMode');
    var initialValue = $(this).parent("div").attr("initial_value")
    $(this).parents("td").html(initialValue);
});
// Save edition
$('#entriesTable tbody').on('click', '.saveCellEdition', function () {
    var initialValue = $(this).parent("div").attr("initial_value");
    var newValue = $(this).parent("div").find('input').val();
    var $row = $(this).parents('tr');
    var $cell = $(this).parents("td");
    $cell.html(newValue);
    $.ajax({
        url : "/forms/change-entry-field-value/{{ form._id }}",
        type: "POST",
        dataType: "json",
        contentType: 'application/json;charset=UTF-8',
        data: JSON.stringify(getRowData($row)),
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            $cell.removeClass('cellEditionMode');
            if (data.saved != true) {
                $cell.html(initialValue);
            }else{
                // could improve this to recalculate the given column
                $(".col_sum").hide();
            }
        }
    });    
});
$('#entriesTable tbody').on('click', '.delete-row-icon', function () {
    if(editMode == false){
        console.log(editMode)
        return;
    }
    var $row=$(this).parents('tr');
    if ($row.find(".cellEditionMode").length == 1){
        return
    }
    $.ajax({
        url : "/forms/delete-entry/{{ form._id }}",
        type: "POST",
        dataType: "json",
        contentType: 'application/json;charset=UTF-8',
        data: JSON.stringify({"created": getFieldValueInRow("created", $row)}),
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.deleted == true) {
                $row.children(':not(:first-child)').addClass('deleted-row');
                $row.children('td').eq(0).html('<i class="fa fa-undo undo-delete-row" aria-hidden="true"></i>');
                $(".col_sum").hide();
            }
        }
    });
});
$('#entriesTable tbody').on('click', '.undo-delete-row', function () {
    var $row = $(this).parents('tr');
    $.ajax({
        url : "/forms/undo-delete-entry/{{ form._id }}",
        type: "POST",
        dataType: "json",
        contentType: 'application/json;charset=UTF-8',
        data: JSON.stringify(getRowData($row)),
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.undone == true) {
                $row.children(':not(:first-child)').removeClass('deleted-row');
                $row.children('td').eq(0).html('<i class="fa fa-minus-circle delete-row-icon enabled" aria-hidden="true"></i>');
            }
        }
    });
});
document.getElementById('toggle_notification').addEventListener('click', function(evt){
    $.ajax({
        url : "/form/toggle-notification/{{ form._id }}",
        type: "POST",
        dataType: "json",
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.notification == true) {
                $('#notification_true').addClass('btn-success');
                $('#notification_false').removeClass('btn-primary');
            }
            else if (data.notification == false) {
                $('#notification_true').removeClass('btn-success');
                $('#notification_false').addClass('btn-primary');
            }
        }
    });
});
</script>
{% endif %}

{% endblock %}
